这是一个用于自动化，逆向辅助的框架，无论你的设备在哪里，只要有网便可掌控。
如果你希望继续看下去，请先确保：手头有一台已经ROOT了的安卓设备或者推荐的安卓模拟器（推荐**夜神**，**雷电**模拟器。但是**不支持** AVD、Mumu），对于真机，则推荐运行最接近原生系统的设备如谷歌系、一加、安卓开发板等，或系统仅经过轻度改造的手机设备。目前不能在小米VIVO华为这类重度改造的系统上正常运行。如果你只有小米VIVO华为系的设备，那么建议使用模拟器。

> ### 免责声明

任何用户在使用由 **rev1si0n** (以下称为**本人**) 开发的ASTRO框架 (以下简称 **本框架**) 前，请仔细阅读此声明。
您可以选择**不使用**本框架，若您一旦开始使用，即被视为您同意、认可、接受及不会违反本声明的全部内容。


1. 您承诺遵守 **中华人民共和国** 的 **法律法规**，合法以及合理使用本框架。
2. 您承诺不会利用本框架开展任何侵犯他人合法利益等恶意行为。
3. 任何单位或个人因下载使用本框架而直接或间接产生的任何意外、侵权等任何有关的损失或毁坏，本人不承担任何法律责任。
4. 您明确并同意本声明条款列举的全部内容，对使用本框架可能存在的风险和相关后果将完全由您自行承担，本人不承担任何法律责任。


## 前言

文档目前不是很全，只是介绍了基本使用，也有点杂乱，请配合下方示例手动输入语句辅助理解。如果你使用的是 Windows，附带的任何示例代码/命令可能在你的系统上不会正常工作(但是不包括客户端库)，建议在 Linux 或者 Mac 系统上操作文档及样例中的代码。

**请勿在自用手机上运行**，请勿将运行本框架的**任何**手机、设备暴露于**不可信**的网络/WIFI环境中，**任何人**均可像你一样直接调用具有ROOT权限的接口！服务会上传本身的日志以及系统崩溃信息用于分析调整，其中也包括设备型号/标识符等部分相关系统属性（在使用代理的情况下，还可能包含你访问的IP地址，但不会包含您的登录凭据）除此之外**并不会**触碰任何个人数据、计算/网络资源、或者你用于调用本服务的任何配置信息如代理、VPN。


> 问题反馈及功能建议

仍在开发阶段，点此 [汇报问题/建议](https://github.com/rev1si0n/the-ultimate-astro/issues/new)，请详细描述问题或需求。

## 自动化抓取APP内容

> 这里你将会了解如何编程抓取一个应用

[rev1si0n/the-ultimate-astro-examples](https://github.com/rev1si0n/the-ultimate-astro-examples.git)


## 相关工具及脚本

> 用于简化部分操作的脚本合集

[rev1si0n/the-ultimate-astro-tools](https://github.com/rev1si0n/the-ultimate-astro-tools.git)

## 开机自启动/反检测

此服务支持以安卓原生内置服务的形式自启动，在不再安装任何其它任何ROOT框架的情况下，基本可以百分百过掉任何应用的ROOT检测。
关于使用的**制作工具**，可以参考我的另一个项目 [rev1si0n/bxxt](https://github.com/rev1si0n/bxxt) 。
由于各个机型及系统版本的操作皆不相同，后期将会写部分常见机型的制作教程。

## 安装

> 分为客户端以及服务端，客户端主要是Python相关库及接口，服务端则是运行在设备上的服务。

### 客户端安装

> 通过PIP源直接安装

```bash
pip3 install --force-reinstall 'aletheia-client'
#
#
# 如果你需要使用内置frida，为确保版本兼容请使用下列方法安装
# 不需要请忽略
pip3 install --force-reinstall 'aletheia-client[frida]'
```

> 手动安装

```bash
# 前置条件，需要确保下面两个包已经安装
# 否则打包时可能出错或者无法安装 whl
pip3 install wheel setuptools

# 克隆项目到本地
git clone https://github.com/rev1si0n/the-ultimate-astro.git
# 进入目录
cd the-ultimate-astro
# 打包（也可以直接在 release 页面下载打包好的 .whl 来省略此步骤）
python3 setup.py bdist_wheel
# 这将会在当前目录的 dist 目录下生成一个 .whl 文件，复制文件名
# 正常情况下，它的名字类似于 `aletheia-client-3.0.0-py3-none-any.whl`，复制此文件名称
# 执行命令（后面的 whl 文件名有可能不同，注意替换）
pip3 install --force-reinstall 'dist/aletheia-client-3.0.0-py3-none-any.whl'
# 至此已安装完成。
#
# 如果你需要使用内置frida，为确保版本兼容请使用下列方法安装
pip3 install --force-reinstall 'dist/aletheia-client-3.0.0-py3-none-any.whl[frida]'
```

### 服务端安装

安装前，请先选择合适的架构，可以通过 adb shell 命令 `getprop ro.product.cpu.abi` 来获取当前的系统架构。
正常情况下，对于现时代的手机，可以直接选择 `arm64-v8a` 版本，而对于模拟器如雷电，你会在新建模拟器时选择32或64位版本的安卓系统，
32位模拟器系统对应 `x86`，64位则对应 `x86_64`，正常情况下，雷电模拟器默认创建的为基于 `x86` 的安卓 7.0 系统。

现在，从 `release` 页面 [rev1si0n/the-ultimate-astro/releases](https://github.com/rev1si0n/the-ultimate-astro/releases)
下载对应架构的 `.tar.gz` 文件。假设你已经从上文得知你的手机/设备架构为 `arm64-v8a`，那么在此页面点击
`arm64-v8a.tar.gz` 的链接来下载到本地。


下载完成后，将设备连接到当前电脑并开启 ADB，现在执行：

```bash
adb push arm64-v8a.tar.gz /data/local/tmp
```

静待完成。

进入 `adb shell`，并使用 `su` 命令切换为 root 身份，执行：

```bash
cd /data/local/tmp
# 解包服务端文件（注意自带的 tar 命令可能不支持 z 选项，你可能需要使用 busybox tar 来解包）
tar -xzf arm64-v8a.tar.gz
# 启动服务端
sh arm64-v8a/bin/launch.sh
```

静待结束。随即直接关闭终端，至此服务启动完成，模拟器同理。
注：所有功能完全启动完成可能需大概五分钟左右，在此间请勿使用接口。

## 开始

设备上的 `65000` 端口为本服务的标准端口，大部分情况下，你不需要显式提供此端口。
下面请先在 WLAN 设置中取得**当前设备的IP地址**，下面将会一直**假设**设备的IP为 `DEVICE`。

如果你用不到 SSH，请跳过此段。

> 本服务提供了内置的SSH，你可以直接通过SSH接入手机。
登录的身份将始终为 `root`，你可以在登录后
的 shell 中直接使用内置的 python，这也意味着你可以直接在 shell 中实现对手机的 `自控`。

此 ssh 不支持 xshell，请使用标准 linux 平台 ssh 命令。不支持密码认证，只能使用 pubkey 方式登陆，用于登录的私钥你可以在服务的 etc/ 目录下找到 (`id_rsa`)，将其复制到你的本机，并设置文件权限为600)

执行
```bash
ssh -i id_rsa -p 65000 root@DEVICE
```
即可进入设备中具有root权限的 ssh shell。

> 在网页端直接控制手机。

在浏览器中打开 `http://DEVICE:65000/control` 即可进入 web 控制界面，打开 `http://DEVICE:65000/status` 则可以查看设备的状态信息。
好了，琐碎的功能已经介绍完毕，现在，将配合 client 库进行介绍，在开始前，请先确保你已经根据上文 `客户端安装` 章节正确安装了客户端库。

## 连接设备

```python
from aletheia.client import *

d = Device(DEVICE)
```

或者，直接执行命令
```bash
# 注意这个DEVICE参数是IP，自行替换
python3 -m aletheia.client -device DEVICE
# 随后可以直接在此 shell 中输入下方语句
```

> 下文中的 `d` 将始终假设为 `d = Device(DEVICE)` 实例。

## 设置 http/socks5 代理
> 只支持 http 以及 socks5 代理作为上游服务器，**特别注意**：仅对设置之后建立的TCP连接有效,
> 之前建立的连接不会通过代理，所以你可能需要重启目标APP。

```python
profile = GproxyProfile()
# socks5 代理则为 GproxyType.SOCKS5
profile.type = GproxyType.HTTP_CONNECT
# 如果你需要重定向 DNS 查询到 114.114.114.114
# 注意此 DNS 是系统全局的，系统发出的所有DNS将会被转发
# 如果是与OpenVPN同存的情况，此配置不可以设置为OpenVPN
# 的内网DNS服务器，否则可能会导致彻底断网
# 去掉 nameserver 配置行将不会修改DNS
profile.nameserver = "114.114.114.114"
profile.host = "代理服务器地址"
profile.port = 代理服务器端口

# 如果这个代理服务器需要登录信息（注意：如果没有，请置为 None 或者删除这两行）
profile.password = "代理服务器登录密码"
profile.login = "代理服务器登录用户"

# 注意目前无法通过TCP代理转发UDP流量，所以APP发出的任何UDP流量都是不经过代理的！
# 你需要注意APP可能通过此方法获取你的真实地址，设置此参数为 True，这样
# APP 发出的所有UDP流量将被丢弃，否则UDP流量将直接通过本地网络发出
profile.drop_udp = True

# 如果需要仅对特定APP应用代理（例如安卓浏览器，如果是全局则删除这两行）
info = d.appliation("com.android.browser").info()
profile.application.CopyFrom(info)

# 启动代理
d.start_gproxy(profile)
# 关闭代理
d.stop_gproxy()
```

## 中间人流量劫持(MITM)

请先确保你已经准备好 fiddler,mitmproxy给你的证书，对于 mitmproxy，
给你的证书为 pem 格式如下示例。而对于 fiddler，则可能是 crt 格式，直接将该文件
作为参数提供即可无需关心转换问题。

```python
# 以 mitmproxy 为例，使用如下代码安装证书
d.install_ca_certificate("~/.mitmproxy/mitmproxy-ca-cert.pem")
# 使用如下代码卸载证书（如不常变化不建议频繁安装卸载）
d.uninstall_ca_certificate("~/.mitmproxy/mitmproxy-ca-cert.pem")
```

接着，看 `设置 http/socks5 代理` 节，将代理设置为中间人应用监听的地址即可。
按照流程完成后如果没有截获到流量请参加设置代理部分的**特别注意**。

## 设置 OpenVPN

> 此 OpenVPN 只支持使用证书登录，可以与 http/socks5 代理共存。
> 需要注意的是，部分配置项例如 all_traffic 可能会与服务器端配置存在关联，只有在服务器端配置为
> 非全局 VPN (只VPN特定网段）下才会生效。只包含VPN的主要功能，除了 `DNS` 配置，暂无法应用服务端推送的其他配置信息。

```python
profile = OpenVPNProfile()

# 是否全局 VPN，为 False 时仅路由服务器端推送的特定网段
profile.all_traffic  = True
# 服务器端开启的连接协议 (或者为 OpenVPNProto.TCP)
profile.proto        = OpenVPNProto.UDP
profile.host         = "OpenVPN 服务器地址"
profile.port         = OpenVPN 服务器端口
# 服务器端通道加密方法
profile.cipher       = OpenVPNCipher.AES_256_CBC

profile.ca = """
-----BEGIN CERTIFICATE-----
服务端配置的 ca 证书
-----END CERTIFICATE-----
"""

profile.cert = """
-----BEGIN CERTIFICATE-----
客户端证书
-----END CERTIFICATE-----
"""

profile.key = """
-----BEGIN PRIVATE KEY-----
客户端私钥
-----END PRIVATE KEY-----
"""

# 启动 OpenVPN
d.start_openvpn(profile)
# 关闭 OpenVPN
d.stop_openvpn()
```

> 示例的 OpenVPN server 端配置文件（请勿直接复制，依据事实进行修改挑选）

服务端的搭建涉及到较多系统配置以及防火墙配置可能较为复杂，自行部署的话建议尽量使用公开的docker进行。
这里不会讲述如何搭建。

```
user nobody
group nogroup

topology subnet
server 192.168.168.0 255.255.255.0
proto udp
port 1233
dev tun
txqueuelen 1000
ncp-disable
cipher AES-256-CBC

# 注意你可能会遇到客户端不断重连的状况
# 因为安卓设备在息屏状态下，网络可能会由于省电措施中断
# 你可能会需要更改此处配置但是有利弊
keepalive 60 300

ca         /etc/openvpn/server/keys/ca.crt
dh         /etc/openvpn/server/keys/dh2048.pem
cert       /etc/openvpn/server/keys/ovpn.crt
key        /etc/openvpn/server/keys/ovpn.key
crl-verify /etc/openvpn/server/keys/crl.pem

client-to-client

# 去掉注释为始终全局，即代表上文的 all_traffic 配置即使设为 False 也相当于 True
# 所以这里直接注释掉此配置（不要加入此配置）
#push "redirect-gateway def1 bypass-dhcp"

push "route x.x.x.x 255.255.255.0"

# 始终只会使用第一个 DNS，其他将会被忽略
push "dhcp-option DNS 114.114.114.114"
push "dhcp-option DNS 114.114.115.115"

# *** 暂不支持 *** PROXY_AUTO_CONFIG_URL push
#push "dhcp-option PROXY_AUTO_CONFIG_URL https://example.com/proxy.pac"

# 同一个证书是否允许多个客户端使用
#duplicate-cn
verb 4
```

## 如何连接内置 frida

> 非逆向从业无需认识此节

1. 通过代码连接

```python
device = d.frida
device.enumerate_processes()
```
等效于 (哪个更方便可以一眼看出，肯定是上面)
```python
manager = frida.get_device_manager()
device = manager.add_remote_device("DEVICE:65000")
device.enumerate_processes()
```

2. 通过命令行连接
```bash
frida -H DEVICE:65000 -f com.android.settings
```

即可。

## 如何远程控制离我十万八千里的设备

有时候你可能遇到这种情况：你的手机在办公室，或者，你的手机在家里而你想在任何另一地点接入设备。
在家里控制办公室的手机进行打卡是一个用途（当然其他方案很多）。这是一种情况，大部分情况下，我们可能需要将设备
接入云端。

在开始前，你可能需要先准备一台公网服务器，具备基本的 linux 编辑修改文件的能力。

本服务使用了较为成熟的端口转发程序 [fatedier/frp](https://github.com/fatedier/frp)，关于如何配置服务端，请在此项目中自行探索。
这里不会讲述如何配置此服务。**需要提醒**，请勿将转发后的端口绑定到公网地址，请确保你的公网服务器关闭了所以不必要的端口！
当然，会给你一个最简单的配置，可以直接使用如下命令启动服务端
```bash
frps --token yespassword --bind_addr 0.0.0.0 --bind_port 6009 --proxy_bind_addr 127.0.0.1
```

随后，复制下列配置并修改**服务器地址**为你的服务器公网IP
```ini
fwd.host=服务器地址
fwd.port=6009
fwd.rport=2022
fwd.token=yespassword
fwd.protocol=tcp
fwd.enable=true
```
进入设备的 ssh 命令行，执行

```bash
nano properties.local
```
将修改的配置粘贴或自行输入，并保存，随后重启设备即可。

最后，在远端服务器使用客户端库
```python
from aletheia.client import *
# 端口为上面的 rport
d = Device("127.0.0.1", port=2022)
# 其余任何接口调用实现均统一，无需做改动
```
进行连接。

注: 本地到服务器端的通信已由FRP自带传输加密功能进行压缩加密。


## 如何使设备连接国际互联网

如果你有*正规*的OpenVPN服务，可以直接连接。如果没有，可使用 SS 之类将其先转换为socks5代理随后通过上文socks代理设置进行设置。同时请自建无污染DNS，否则你仍可能无法连接。
OpenVPN 及 socks 可以共存，你可以为每一台设备接入相同的内网并在内网搭建相关 socks5 服务 (ss-server -> ss-client -> socks5)

需要注意的是，这些VPN/代理是纯正的代理，不包含任何自动代理脚本配置(pac)支持等，也不会支持。

## 系统属性 (get/setprop)

> 设置/读取系统属性

```python
# 获取 ro.secure 的值
d.getprop("ro.secure")

# 设置 ro.secure 的值
d.setprop("ro.secure", "0")
```

## 系统设置 (settings)

> 设置/读取安卓系统设置

```python
settings = d.stub("Settings")

# 示例：获取及修改屏幕亮度
settings.get_system("screen_brightness")
settings.put_system("screen_brightness", "5")

# 示例：关闭开发者选项
settings.get_global("development_settings_enabled")
settings.put_global("development_settings_enabled", "0")

# 示例
settings.get_secure("screensaver_enabled")
settings.put_secure("screensaver_enabled", "0)
```

## 设备状态

> 获取设备运行信息
```python
status = d.stub("Status")

# 获取设备启动时间
status.get_boot_time()

# 获取设备磁盘使用情况
status.get_disk_usage(mountpoint="/data")

# 获取电池信息
status.get_battery_info()
# 获取CPU使用情况
status.get_cpu_info()
# 获取总体磁盘读写情况
status.get_overall_disk_io_info()
# 获取总体网络收发情况
status.get_overall_net_io_info()
# 获取内存使用情况
status.get_mem_info()
```

## 脚本执行

> 在目标设备后台，前台执行 shell 脚本

```python
shell = d.stub("Shell")
# 执行前台脚本
shell.execute_script("pwd")

# 执行后台脚本
ID = shell.execute_background_script("sleep 100; exit 0;")
# 检查后台脚本是否结束
shell.is_background_script_finished(ID)
# 强制结束后台脚本
shell.kill_background_script(ID)
```

## IDA 调试

> 内置了IDA 7.0服务端

```python
debug = d.stub("Debug")

# 启动 IDA 32服务端
debug.start_ida(port=19887)
# 检查是否已启动
debug.is_ida_running()
# 关闭IDA 32服务端
debug.stop_ida()
# 如果调试的是64位程序，将方法名中的 ida 替换为 ida64 即可
# 例如
debug.start_ida64(port=29999)
```

## 文件操作

> 将文件上传至目标设备或从其下载文件（支持大文件）

```python
# 下载文件到本地
d.download_file("/data/local/tmp/设备上的文件.txt", "写入到的本地文件.txt")

# 上传文件到设备
# 会自动修改远程的文件权限信息为本地文件权限信息
# 即本地文件权限为 0755，那么上传到设备上的文件也为此权限
d.upload_file("本地文件路径.txt", "/data/local/tmp/上传到设备上的文件.txt")

# 删除设备上的文件
d.delete_file("/data/local/tmp/文件.txt")

# 修改设备上的文件权限
d.file_chmod("/data/local/tmp/文件.txt", mode=0o777)

# 获取设备上文件的信息
d.file_stat("/data/local/tmp/文件.txt")
```

## 应用操作

> 列出系统上已安装的所有应用的ID

```python
d.enumerate_all_pkg_names()
```

> 获取当前处于前台的应用

```python
d.current_application()

# 等价于
d.application(d.current_application().applicationId)

# 获取当前前台的 activity
d.current_application().activity
```

> 启动 Activity
```python
# 附加数据只支持 int 以及 string 类型
d.start_activity(action=, category=, component=, extras={"int": 1, "string": "me"})

# 例如：进入证书设置
d.start_activity(action="com.android.settings.TRUSTED_CREDENTIALS")
```

> 授予/撤销 APP 权限

注意，你应在APP未启动时进行权限设置，在APP请求时调用并不会产生帮你点击允许的效果。

```python
app = d.application("com.my.app")

# 获取应用所有权限
app.permissions()
# 授予 READ_PHONE_STATE 权限
app.grant("android.permission.READ_PHONE_STATE", mode=GrantMode.ALLOW)
# 拒绝 READ_PHONE_STATE 权限
app.grant("android.permission.READ_PHONE_STATE", mode=GrantMode.DENY)
# 检查是否已授予权限
app.is_permission_granted("android.permission.READ_PHONE_STATE")
# 撤销已授予的权限
app.revoke("android.permission.READ_PHONE_STATE")
```

> 清除应用缓存，重置应用

```python
# 删除应用的缓存数据
app = d.application("com.my.app")
app.delete_cache()
# 重置应用数据
app.reset_data()
```

> 启动/停止应用

```python
app = d.application("com.my.app")

# 启动应用
app.start()
# 检查应用是否正在前台运行
app.is_foreground()
# 关闭应用
app.stop()
```

> 其他

```python
app = d.application("com.my.app")
# 获取应用信息
app.info()

# 检查应用是否已安装
app.is_installed()
# 卸载应用
app.uninstall()

# 启用应用
app.enable()
# 禁用应用
app.disable()
```

## WIFI操作

目前WIFI操作部分功能由于可能导致问题未实现，仅介绍部分实现的功能

```python
wifi = d.stub("Wpa")

# 获取wifi bssid,ssid ip 等相关信息
wifi.status()

# 获取黑名单中的所有 bssid
wifi.blacklist_get_all()

# 将bssid加入黑名单(将不会显示在wifi列表)
wifi.blacklist_add("3c:06:aa:8a:55:66")

# 清空所有黑名单
wifi.blacklist_clear()

# 执行 wifi 扫描
wifi.scan()

# 获取周边 wifi 扫描结果
wifi.scan_results()

# 获取当前wifi的mac地址
wifi.get_mac_addr()

# 获取 wifi 信号强度，链接速率
wifi.signal_poll()
```

## 基本UI操作

> 获取设备信息

```python
d.device_info()
```

> 息屏/亮屏相关

```python
# 息屏
d.sleep()
# 亮屏
d.wake_up()
# 屏幕是否点亮
d.is_screen_on()
# 屏幕是否已锁定
d.is_screen_locked()
```

> 剪切板

```python
d.set_clipboard("剪切板内容")

# 获取剪切板内容（不支持安卓10+）
d.get_clipboard()
```

> 物理按键

```python
d.press_key(Key.KEY_BACK)
```

> 屏幕截图

```python
quality = 60 # 截图质量
d.take_screenshot(quality).save("screenshot.png")
# 截取屏幕上特定区域的图像
# Bound 的参数 top,left 等定义：

# top:     从距离屏幕顶部 N 像素开始
# bottom:  到距离屏幕顶部 N 像素结束
# left:    从距离屏幕左侧 N 像素开始
# right:   到距离屏幕左侧 N 像素结束

# top 永远小于 bottom，left 永远小于 right
bound = Bound(top=50, bottom=80, left=50, right=80)
d.take_screenshot(quality, bound=bound).save("partial.png")
```

> 点击屏幕上的一个点

```python
d.click(Point(x=100, y=100))
```

> 点按点A并将其拖动到点B

```python
A = Point(x=100, y=100)
B = Point(x=500, y=500)

d.drag(A, B)
```

> 从点A滑动到点B

```python
A = Point(x=100, y=100)
B = Point(x=500, y=500)

d.swipe(A, B)
```

> 稍复杂的多点滑动（九宫格解锁）

```python
p1 = Point(x=100, y=100)
p2 = Point(x=500, y=500)
p3 = Point(x=200, y=200)

# 从点P1滑动到点P2随后滑动到点P3
d.swipe_points(p1, p2, p3)
```

> 打开通知栏/快捷设置栏

```python
d.open_notification()
d.open_quick_settings()
```

> 获取页面布局描述XML

```python
d.dump_window_hierarchy().getvalue()
```

> 等待界面布局停止刷新

```python
# 单位是毫秒，5*1000 代表5秒
d.wait_for_idle(5*1000)
```

## 进阶UI操作

> Selector

界面选择器，类似于网页，安卓的界面也可以通过选择器进行元素的选择。
在开始了解前，请先安装第三方的 [alibaba/web-editor](https://github.com/alibaba/web-editor)，你可以通过
```bash
pip3 install weditor
```
直接安装。

随后，在命令行输入 `weditor` 启动，你会自动跳转到相关页面，在顶部连接设备区域输入 `设备IP:65000` 并点击 CONNECT 进行连接。
注意，暂仅支持其UI审查功能，请不要使用右侧代码运行/实时等功能。

连接到设备后，点击 `Dump Hierarchy` 来获取当前界面布局，你可以将其想象成打开了开发者工具并得到DOM布局。

这样，你可以在左侧页面屏幕上选择你感兴趣的元素，在页面中部 `Selected Element` 区域将会显示其属性。
你可以将其中的大部分属性作为 Selector 的参数。

正常情况下，我们只会使用 `resourceId`, `clickable`, `text`, `description` 作为参数。
如果元素存在正常的 resourceId，优先使用其作为 Selector，即：`Selector(resourceId="com.android.systemui:id/mobile_signal_single")`。
对于无 resourceId，则会使用其 text，即：`Selector(text="点击进入")`，或者更模糊一点 `Selector(textContains="点击")`
description 与 text 同理，但是 description 用的会比较少。

当然，Selector 不止可以使用一个参数，你可以做其他组合，例如 `Selector(text="点击进入", clickable=True)`

所有常见的匹配参数：

```
text                    文本完全匹配
textContains            文本包含匹配
textStartsWith          文本起始匹配
className               类名匹配
description             描述完全匹配
descriptionContains     描述包含匹配
descriptionStartsWith   描述起始匹配
clickable               可以点击
longClickable           可以长按
scrollable              可滚动
resourceId              资源ID匹配
```

大部分情况下，你不会直接用到 `Selector`，但是间接使用无处不在。

> 元素操作

上文都是介绍了如何坐标点击这种随意性的东西，现在开始介绍如何操作固定目标元素。首先，你需要知道如何选定元素。
如果看不太懂，可配合 [rev1si0n/the-ultimate-astro-examples](https://github.com/rev1si0n/the-ultimate-astro-examples.git) 示例运行观看。

```python
# 选择界面上的包含文字 某APP 的元素
element = d(textContains="某APP")
# 当然，你不一定要这样赋值到 element，也可直接使用 d(textContains="某APP")
```

好了，现在你知道了如何获取元素了，当然，这时并没有获取到，只是代表，你想要在当前界面操作这个元素，下面开始操作。


```python
# 我们现在假设，界面上这个 某APP 是手机上某APP的图标名称（图标下面的名称）。
element = d(textContains="某APP")
# 是否存在该元素
element.exist()
# 点击该元素，不存在则会抛出异常
# Corner.COR_CENTER 代表点击该元素中心点，你可查看 COR_CENTER 定义获取其他可点击的位置
element.click(corner=Corner.COR_CENTER)

# 点击该元素，不存在不会抛出异常
element.click_exist(corner=Corner.COR_CENTER)

# 长按该元素，不存在则会抛出异常
element.long_click(corner=Corner.COR_CENTER)

# 获取元素信息
element.info()

# 获取元素个数
element.count()

# 等待元素出现，最多等待10秒
element.wait_for_exists(10*1000)

# 等待元素消失，最多等待10秒
element.wait_until_gone(10*1000)

# 获取该元素的截图（不是全屏，只是该元素）
# quality 为截图质量 1-100
element.take_screenshot(quality=60)

# 将此 APP 拖动归类到 购物 文件夹（依据实际情况修改）
element.drag_to(Selector(text="购物"))


############################
# 现在 element 改变了其意义，变为选择了输入框
############################

# 示例为：在一加搜索应用界面的搜索框输入 某APP

# 注意，不要直接往看似输入框的地方输入文字，可能并无法输入
# 有些输入框需要点击一次才会进入真正的输入框，请使用此真正输入框的资源ID
element = d(resourceId="net.oneplus.launcher:id/search_all_apps")
element.set_text("某APP")

# 获取输入的内容
element.get_text()

# 清空刚刚输入的内容
element.clear_text_field()

# 配合点击搜索，来完成一次类人的搜索操作。


# 滑动操作（列表上下滑动翻页）
# 注意，这些操作并不保证精度，下面这些方法正常情况下都并不需要选择器，
# 但是你可根据实际情况自行加入选择器

# 向上滑动， step 自行调整，越多会越慢，比较适合精度要求较高的滑动
d().swipe(direction=Direction.DIR_UP, step=32)
# 其他滑动方向：
#DIR_UP     向上滑动
#DIR_LEFT   向左滑动
#DIR_DOWN   向下滑动
#DIR_RIGHT  向右滑动

#########
# fling：甩动，即正常人滑动屏幕的行为，较快
#########
# 从上向下
d().fling_from_top_to_bottom()
# 从下往上
d().fling_from_bottom_to_top()
# 从左往右
d().fling_from_left_to_right()
# 从右往左
d().fling_from_right_to_left()

# 其他，一直向下/左右上滑，直到滑动到底
# 因为并不是一定可以滑动到底或者检测到滑动到底
# 所以 max_swipes 参数是必须的
d().fling_from_top_to_bottom_to_end(max_swipes=32)
d().fling_from_bottom_to_top_to_end(max_swipes=32)
d().fling_from_left_to_right_to_end(max_swipes=32)
d().fling_from_right_to_left_to_end(max_swipes=32)

#########
# scroll: 比较机械性的滑动
#########
step = 60
max_swipes = 32
# 从上往下滑动 step 步
d().scroll_from_top_to_bottom(step)
# 从下往上滑动 step 步
d().scroll_from_bottom_to_top(step)
# 从左往右滑动 step 步
d().scroll_from_left_to_right(step)
# 从右往左滑动 step 步
d().scroll_from_right_to_left(step)

# 其他，一直向下/左右上滑，直到滑动到底
# 同上文 fling 描述
d().scroll_from_top_to_bottom_to_end(max_swipes, step)
d().scroll_from_bottom_to_top_to_end(max_swipes, step)
d().scroll_from_left_to_right_to_end(max_swipes, step)
d().scroll_from_right_to_left_to_end(max_swipes, step)
```

> 监视器

监视器用来监听界面变化并在满足条件时执行设定的操作（点击元素或者按键），这可能对性能或者需要人工介入时产生影响，所以请谨慎使用，默认未开启。

```python
# 启动监视器循环
d.set_watcher_loop_enabled(True)

# 获取监视器是否已启动
d.get_watcher_loop_enabled()

# 移除系统中应用的所有 watcher，建议每次使用前都执行防止前面任务注册的未删除影响正常处理流程
d.remove_all_watchers()

# 获取系统中所有已应用的 watcher 名称列表
d.get_applied_watchers()

# 彻底移除一个 watcher
d.remove_watcher(name)

# 应用watcher到系统中（当 watcher_loop 启动，此watcher将会生效）
d.set_watcher_enabled(name, True)
# 取消应用
d.set_watcher_enabled(name, False)

# 获取此 watcher 是否应用
d.get_watcher_enabled(name)
```

> 监视系统界面出现某个元素的次数

```python
# 做一些测试前的清理，当然，并不是每 register 一个就需要这样
# 只是为了确保测试过程不被干扰
d.remove_all_watchers()
d.set_watcher_loop_enabled(True)

# 应用监视界面出现 好的 的次数
# 第二个参数为数组，可以给多个 Selector 表示条件都满足才会记录
# 但是不建议超过三个
d.register_none_op_watcher("RecordElementAppearTimes", [Selector(textContains="好的")])
d.set_watcher_enabled("RecordElementAppearTimes", True)

# ... 做满足条件的操作

# 获取记录的次数
d.get_watcher_triggered_count("RecordElementAppearTimes")

# 重置记录的次数
d.reset_watcher_triggered_count("RecordElementAppearTimes")

# 移除
d.remove_watcher("RecordElementAppearTimes")
```


> 当界面出现匹配元素时点击某个元素

```python
# 做一些测试前的清理，当然，并不是每 register 一个就需要这样
# 只是为了确保测试过程不被干扰
d.remove_all_watchers()
d.set_watcher_loop_enabled(True)

# 示例为，当APP启动后出现用户协议时，自动点击同意
# 第二个参数为数组，可以给多个 Selector 表示条件都满足才会点击
# 但是不建议超过三个
d.register_click_target_selector_watcher("ClickAcceptWhenShowAggrement", [Selector(textContains="用户协议")],
                                         Selector(textContains="同意", clickable=True))
d.set_watcher_enabled("ClickAcceptWhenShowAggrement", True)

# ... 做满足条件的操作

# 移除
d.remove_watcher("ClickAcceptWhenShowAggrement")
```


> 当界面出现匹配元素时点击物理按键

```python
# 做一些测试前的清理，当然，并不是每 register 一个就需要这样
# 只是为了确保测试过程不被干扰
d.remove_all_watchers()
d.set_watcher_loop_enabled(True)

# 示例为，当界面存在 个人中心 时，按下HOME键回到启动屏幕
# 第二个参数为数组，可以给多个 Selector 表示条件都满足才会点击
# 但是不建议超过三个
d.register_press_key_watcher("PressBackWhenHomePageShows", [Selector(textContains="个人中心")], Keys.KEY_HOME)
d.set_watcher_enabled("PressBackWhenHomePageShows", True)

# ... 做满足条件的操作

# 移除
d.remove_watcher("PressBackWhenHomePageShows")
```

## 终极操作

这是本项目的最后一个最不程式化的接口了，他可以让你从设备上录制你的滑动轨迹并在设备上重放，如果你做过爬虫验证，
那么你可能遇到过滑动验证码的情况，机械性的拖动可能可以但绝不是最佳方法。

此接口也主要用来在实践中进行类人的滑动操作，即你在屏幕上怎么滑动，调用接口重放时仍然相同。
如果你希望继续看下去，你需要有一台安装了服务端的真实手机设备。

> 注意: 只支持在相同屏幕大小的设备上重放。

你应该看过上面怎么连接入设备的SSH shell了，如果你不知道什么是SSH，那么请自己解决。
连接入 shell 后，进入 `/data/local/tmp`，执行命令 `mt-record`，
此时，此程序应该会卡住你的 shell，现在你可以拿起手机了。

你在屏幕上的**每次滑动**都会生成一个文件，例如 `0000.rec`, `0001.rec`..
随后，将一个你比较满意的文件 `adb pull` 到本地例如 `adb pull /data/local/tmp/0001.rec`。

样例代码
```python
seq = multitouch_cmds_to_action_sequence(open("0001.rec", "rt").read())
d.perform_touch(seq)
```

TIPS: 打开开发者选项并打开 `指针位置` 可显示滑动轨迹。

具体介绍可能较多，所以这里目前不再叙述。
对于需要精确编程控制的需求，你可以自行生成一个 sequence，用AI生成那么将是极好的。
同样，你也可以直接在通过 rec 文件转换的序列上进行局部修改来适配你需要的滑动操作。
具体用途将看你的想象力及需求了。

